 /*
Function list:
Draw - This is an Object
drawImage - same as canvas's draw image, but failsafe. 
            if you have an image "\webdune\data\dune2\img\dir\error.bmp"
            and want to draw it, you should add it to cache list and draw it with 
            drawImage("dir/error.bmp", x, y)
drawMap - draws the map as in Map object.
          If a cell is occupied, we call the draw Object
drawUI - draws User Interface, menu and sidepanel
drawObject - draw's the object.
*/



function Draw(map, objects, game, canvas)
{
    this.REDRAW_UI = true;
    var self = this;
    /*
    this.REDRAW_MAP = true;
    this.REDRAW_MINIMAP = true;
    this.REDRAW_CONTROLPANEL = true;*/
    
    this.drawFillSquare = function(pos,size,color)
    {/*
        if (!isNumeric(pos[0]) || !isNumeric(pos[1]) || !isNumeric(size[0]) || !isNumeric(size[1]))
        {
            deb("could not draw a simple square! "+pos+" "+size);
            return;
        }*/
        this.canvas.fillStyle = color;
        this.canvas.fillRect(pos[0],pos[1],size[0],size[1]);
    }
	
        
    // the main draw function
    this.drawImage = function(img,x,y,width,height,dx,dy,dWidth,dHeight)
    {
        if (img==undefined || x==undefined || y==undefined)
        {
            deb("failed to draw "+img+": "+x+","+y+","+width+","+height)
			return;
        }
        if (!IMAGES_PRELOADED)
        {
            deb("the images are not loaded yet");
            return;
        }
        //deb(img+" "+x+" "+y+" "+width+" "+height+" "+dx+" "+dy+" "+dWidth+" "+dHeight);
        //if the image is not cached
		if (imageCache[img] == undefined)
		{
			imageCache[img] = new Image();
			imageCache[img].src =  "/"+settings.baseDir+"/data/imagecolor.php?img="+img;
            img = "error.bmp";
        }	
        if (!imageCache[img].complete)
		{
			// if not even being cached, its prolly a custom color image
			
            img = "error.bmp";
		}

		if (img == "error.bmp")
		{
			if (dWidth != undefined && dHeight != undefined)
			{
				this.canvas.drawImage(imageCache[img],dx,dy,dWidth,dHeight);
				return;
			}
            this.canvas.drawImage(imageCache[img],x,y,width,height);
			return;
		}
			
            
        
        if (width != undefined && height != undefined)
        {
			if (dx != undefined && dy != undefined)
			{
				if (dWidth != undefined && dHeight != undefined)
				{
					this.canvas.drawImage(imageCache[img],x,y,width,height,dx,dy,dWidth,dHeight);
					return;
				}
				this.canvas.drawImage(imageCache[img],x,y,width,height,dx,dy);
				return;
			}
            this.canvas.drawImage(imageCache[img],x,y,width,height);
            return;
        }
        
        this.canvas.drawImage(imageCache[img],x,y);
    }
	

    this.game = game;
    this.canvas = canvas;
    this.map = map;
    this.objects = objects;
	
	
	this.drawFogOfWar = function()
	{
		var size = settings.tileSize;
		var pos = settings.visualMapPosition;
		
		for (var x = 0; (x*size) <= settings.visualMapSize[0]; x ++)
			for (var y = 0; (y*size) <= settings.visualMapSize[1]; y ++)
			{
				var fog = map.fow.isNotVisible([x+map.scroll[0],y+map.scroll[1]]);
				if (fog == 2)
				{
					this.drawFillSquare([(x*size)+pos[0],(y*size)+pos[1]],[size,size],"black");
				}
				if (fog == 1)
				{
					this.drawFillSquare([(x*size)+pos[0],(y*size)+pos[1]],[size,size],"rgba(0,0,0,0.5)");
				}
			}
	}
    
    this.drawMap = function()
    {
        var s = settings;
        
		//deb(this.map.scroll);
		/*
		deb(this.map.map+" "+
            this.map.scroll[0]*s.tileSize+" "+
            this.map.scroll[1]*s.tileSize+" "+
            s.visualMapSize[0]*(16/s.tileSize)+" "+
            s.visualMapSize[1]*(16/s.tileSize)+" "+
            s.visualMapPosition[0]+" "+
            s.visualMapPosition[1]+" "+
            s.visualMapSize[0]+" "+
            s.visualMapSize[1],1);*/
		
        this.canvas.drawImage(
            // map image
            this.map.map,
            // define witch part of the map image we want to draw 
            this.map.scroll[0]*s.tileSize, 
            this.map.scroll[1]*s.tileSize,
            s.visualMapSize[0]*(16/s.tileSize),
            s.visualMapSize[1]*(16/s.tileSize),
            // map position in te screen.
            s.visualMapPosition[0],
            s.visualMapPosition[1],
            s.visualMapSize[0],
            s.visualMapSize[1]
        );
        
    }
    
    this.drawUI = function()
    {
        this.drawImage("ui/menubar.png",0,0);
        this.drawImage("ui/sidebar.png",240,40);
    }
	
	this.bullets = Array();
    
    this.drawGameObject = function(obj)
    {
        if (!obj)
            return;
        
		if (obj.isUnderConstruction && obj.descriptor.isUnit)
			return;
			
        var size = settings.tileSize;
        var imgpos = [(obj.cellXY[0]-map.scroll[0])*size+settings.visualMapPosition[0],
                      (obj.cellXY[1]-map.scroll[1])*size+settings.visualMapPosition[1]];
        if (!within(imgpos, settings.visualMapPosition, settings.visualMapSize))
			return;
        var img = obj.descriptor.img;
        
        var pos = [imgpos[0]+(obj.cellXYAdd[0]*size), imgpos[1]+(obj.cellXYAdd[1]*size)]
        
        // image type. here we parse the image so that we can get correct heading from it.
        if (obj.descriptor.imgtype == "long8")
        {
			if (obj.action != "explode")
			{
				img = img+"&color="+settings.playerColor[obj.owner]+"&datadir="+settings.dataDir;
			}
			var val = size;
				if (imageCache[img] != undefined)
					if (imageCache[img].complete)
						val = imageCache[img].height;
				
            var offset = ((val-16)/2) / (16/size);
			
			
            this.drawImage(img, obj.direction*val, 0, val, val, 
            pos[0]-offset, pos[1]-offset,
            size+offset*2, size+offset*2);
			
			if (obj.action == "harvest")
			{
				this.drawImage("other/harvestersand.png", obj.direction*val, 0, val, val, 
					pos[0]-offset, pos[1]-offset,
					size+offset*2, size+offset*2);
			}
			if (obj.fire && obj.fire != "undefined")
			{
				this.drawImage("shoot/"+obj.desc+".png", obj.direction*val, 0, val, val, 
					pos[0]-offset, pos[1]-offset,
					size+offset*2, size+offset*2);
			}
        }
        if (obj.descriptor.imgtype == "troop")
		{
			if (obj.action != "explode")
			{
				img = img+"&color="+settings.playerColor[obj.owner]+"&datadir="+settings.dataDir;
				
				var shoot = false;
				if (obj.fire && obj.fire != "undefined")
				{
					shoot = true;
				}
				
				var move = Math.round(2*(Math.max(Math.abs(obj.cellXYAdd[0]),Math.abs(obj.cellXYAdd[1]))));
				
				var numberOfUnits = 5*(obj.hp/obj.descriptor.maxhp);
				
				var unitPos = Array([4,4],[10,0],[0,0],[0,7],[10,7]);
				
				for (var i = 0; i < numberOfUnits; i ++)
				{
					this.drawImage(img, obj.direction*6, move*8, 6, 8, 
						pos[0]+unitPos[i][0], pos[1]+unitPos[i][1],
						6, 8);
					if (shoot)
					{
						this.drawImage("shoot/"+obj.desc+".png", obj.direction*6, 0, 6, 8, 
						pos[0]+unitPos[i][0], pos[1]+unitPos[i][1],
						6, 8);
					}
				}
			}
			else
			{
				img = "bullets/blood.png";
				this.drawImage(img, pos[0]+4, pos[1]+4,8,8);
			}
		}
        
        if (obj.descriptor.imgtype == "static")
        {
			if (obj.isUnderConstruction)
				img = "buildings/foundation2.png";
            this.drawImage(img, imgpos[0], imgpos[1], 
				size*obj.descriptor.size[0],size*obj.descriptor.size[1]);
        }
		if (userinput.selected != undefined)
		{
			if (userinput.selected[0] != undefined)
			{
				for (var o in userinput.selected)
					if (userinput.selected[o].id == obj.id)
                		this.drawSelect(pos);
			}
            else if (userinput.selected.id == obj.id)
			{
				var thesize;
				if (!userinput.selected.descriptor.isUnit)
					thesize = userinput.selected.descriptor.size;
                this.drawSelect(pos, thesize);
			}
		}
    }
	
	this.drawBullets = function()
	{
		for (var b in this.bullets)
		{
			this.drawImage(this.bullets[b][0],this.bullets[b][1],this.bullets[b][2]);
		}
		this.bullets = Array();
	}
    
    // draw the X on the selected gameobject.
    this.drawSelect = function (p,thesize)
    {
		if (thesize)
		{
            var size = Array();
            this.canvas.strokeStyle = "green";
			size[0] = settings.tileSize*thesize[0];
			size[1] = settings.tileSize*thesize[1];
			this.canvas.strokeRect(p[0],p[1],size[0],size[1]);
		}
        else if (p)
        {
            this.canvas.strokeStyle = "green";
            var size = settings.tileSize;
            this.canvas.beginPath();
            this.canvas.moveTo(0+p[0],0+p[1]);
            this.canvas.lineTo(size+p[0],size+p[1]);
            this.canvas.moveTo(0+p[0],size+p[1]);
            this.canvas.lineTo(size+p[0],0+p[1]);
            this.canvas.stroke();
        }
    }
    this.drawSelectBuilding = function (p)
    {
        if (p)
        {
            var size = settings.tileSize;
            this.canvas.strokeStyle = "green";
            this.canvas.beginPath();
            this.canvas.moveTo(0+p[0],0+p[1]);
            this.canvas.lineTo(size+p[0],size+p[1]);
            this.canvas.moveTo(0+p[0],size+p[1]);
            this.canvas.lineTo(size+p[0],0+p[1]);
            this.canvas.stroke();
        }
    }
    
    this.drawControlPanel = function()
    {
        // format the area
        //this.drawFillSquare(settings.cpPos, settings.cpSize, "rgb(184,188,148)");
        
        // let game object handle the drawing in the controlpanel
        var dat = userinput.getControlPanelContent();
        if (dat)
        {
            var cont = dat[0];
            for (var c in cont)
            {
                //draw, and add control panel potsition to the location
                this.drawImage(cont[c][0], cont[c][1]+settings.cpPos[0], cont[c][2]+settings.cpPos[1]);
            }
            
            
			var boxes = dat[1];
			for (var b in boxes)
			{
				this.drawFillSquare(
					[boxes[b][0]+settings.cpPos[0],
					boxes[b][1]+settings.cpPos[1]],
					[boxes[b][2],
					boxes[b][3]], 
					boxes[b][4]);
			}
        }
    }
	
	this.drawCredits = function(amount)
	{
		amount = amount+"";
		var pos = [309,4];
		for (var i = 5; i >= 0; i--)
		{
			var num = parseInt(amount.charAt(i+(amount.length-6)));
			if (!isNumeric(num))
				num = 10;
			this.drawImage(
				"fonts/credit.bmp",
				9*num,0,
				9, 9,
				pos[0], pos[1],
				9,9);
			pos[0] -= 10;
		}
	}
	
	this.drawBoxes = function(boxes)
	{
		for (var b in boxes)
        {
            this.drawFillSquare(
            [boxes[b][0],
            boxes[b][1]],
            [boxes[b][2],
            boxes[b][3]], 
            boxes[b][4]);
        }
	}
	
	this.drawMouseObject = function()
	{
		var boxes = userinput.getMouseGirdBoxes();
		if (boxes)
			this.drawBoxes(boxes);
	}
	
	this.drawOccupiedToMinimap = function()
	{
		for (var o in this.objects._obj)
		{
				var obj = this.objects._obj[o];
				if (obj && !map.fow.isNotVisible(obj.cellXY))
				{
					var color = settings.playerColor[obj.owner];
					this.drawFillSquare(
					[settings.minimapPos[0]+Math.floor(obj.cellXY[0]/this.map.minimapRelation[0]),
            		settings.minimapPos[1]+Math.floor(obj.cellXY[1]/this.map.minimapRelation[1])],
					[(1/this.map.minimapRelation[0])*obj.descriptor.size[0],
					(1/this.map.minimapRelation[1])*obj.descriptor.size[1]],
					color);
					//round up, not round.
					/*
					this.drawFillSquare(
					[Math.round(this.map.minimapBoxPos[0]+(this.map.minimapRelation[0]*x)),
            		Math.round(this.map.minimapBoxPos[1]+(this.map.minimapRelation[1]*y))],
            		[Math.round(this.map.minimapRelation[0]),
            		Math.round(this.map.minimapRelation[1])]
					color);*/
					//deb(x+","+y+" "+color);
				}
			}
	}
    
    this.drawMinimap = function()
    {
        // format the area
        this.canvas.drawImage(map.minimap, settings.minimapPos[0], settings.minimapPos[1]);
        
		this.drawOccupiedToMinimap();
		
		this.map.minimapPrecalc();
		//deb(this.map.minimapBoxPos+" "+this.map.minimapBoxSize);
        // draw the box
        this.canvas.strokeStyle = "white";
        this.canvas.strokeRect(this.map.minimapBoxPos[0], 
                this.map.minimapBoxPos[1],
                this.map.minimapBoxSize[0], this.map.minimapBoxSize[1]);
    }
	
	this.selectBoxSpecs = Array();
    this.drawSelectBox = function()
    {
		if (this.selectBoxSpecs[0])
		{
			this.canvas.strokeStyle = this.selectBoxSpecs[4]
			this.canvas.strokeRect(
			this.selectBoxSpecs[0],
			this.selectBoxSpecs[1],
			this.selectBoxSpecs[2],
			this.selectBoxSpecs[3]);
		}
	}
	
	this.drawSpice = function()
	{
		var size = settings.tileSize;
					  
		for (var key in this.map._spice)
		{
			var crd = key.split(",");
			var imgpos = [(crd[0]-map.scroll[0])*size+settings.visualMapPosition[0],
                      (crd[1]-map.scroll[1])*size+settings.visualMapPosition[1]];
			if (within(imgpos, settings.visualMapPosition, settings.visualMapSize))
			{
				crd[0] = parseInt(crd[0]);
				crd[1] = parseInt(crd[1]);
				this.drawImage(
				"other/spice.png",
            	16*this.selectSpiceImage(this.map._spice,crd), 0,
            	16,16,
            	imgpos[0],
            	imgpos[1],
            	size,size);
				var spice = this.map._spice;
			}
		}
	}
    
	this.selectSpiceImage = function(ar,crd){
		var code = 0;
		if (ar[crd[0]+","+(crd[1]-1)]) {
			code += 1;
		}
		if (ar[(crd[0]+1)+","+crd[1]]) {
			code += 2;
		}
		if (ar[crd[0]+","+(crd[1]+1)]) {
			code += 4;
		}
		if (ar[(crd[0]-1)+","+crd[1]]) {
			code += 8;
		}
		
		return code;
	}
}

