// this is the event stack, it should store all commands that are going to happen,
// and send them to game hanlder when the time comes.
// lockStepFilter - this is a sort function to get all the commands that you should send right now.
// update - main loop, filters stuff and executes
// exec - sends the command forward.

function EventStack(time)
{
    this.time = time;
    this._stack = Array();
    var self = this;
   
    
    // update commands, 
    this.update = function()
    {
		this._stack = this._stack.sort(this.commandSort);
        for (DO in this._stack)
        {
			//if ((this._stack[DO].time - this.time.getTime()) > (-settings.lockStepTime))
				//topLayer.setGameMessage("lockstep warning!!");
				
			if (typeof(this._stack[DO]) == "object")
				if (this._stack[DO].time <= this.time.getTime())
                	this.exec(DO);
        }
    }
    
    // execute a command, send it to game
    this.exec = function(id)
    {
        game.doCommand(this._stack[id].id,this._stack[id].time,this._stack[id].command);
        delete this._stack[id];
    }
     
    // sort by time
    this.commandSort = function(cmd1,cmd2)
    {
        return cmd1.time - cmd2.time;
    }
    
    // add a command to the stack
    this.add = function(time,cmd)
    {
		time = parseInt(time);
		if (this.time.getTime() > time)
			topLayer.setGameMessage("lockstep PROLLY OUT OF SYNC");
			
        this._stack[this._stack.length] = new evt([this._stack.length, parseInt(time), cmd]);
        this._stack.sort(this.commandSort);
    }
    // todo: send the command forward to server
    this.sendCommand = function(cmd)
    {
		cmd = (this.time.getTime()+2000)+"&"+cmd+"|";
		if (settings.debug)
		{
			setTimeout(function () { self.unserialize(cmd) }, 500);
			this.messageToSend = "";
		}
		else
			this.messageToSend += cmd;
    }
    
	this.step = 0;
	
    // todo: get command from server
    this.getCommand = function(ret)
    {
		if (ret != undefined)
		{
			ret = ret.split("%");
			session.parsePlayerPings(ret[1]);
			ret = ret[0].split(":");
			this.time.havePermissionForStep = parseInt(ret[1]);
			if (ret[0] && this.step != this.time.havePermissionForStep)
			{
				this.step = this.time.havePermissionForStep;
				this.unserialize(ret[0]);
			}
		}
		setTimeout(function() { self.msg(); },300);
    }
    
    // unserialize the commands in saved file
    this.unserialize = function(serial)
    {
    	if (!serial)
    	return;
        var strings = serial.split("|");
        for (var s in strings)
        {
        	if (strings[s])
			{
            	var evnt = strings[s].split("&");
				if (evnt[1] == undefined)
				{
					session.chatMessage(strings[s]);
				}
				else
					this.add(evnt[0],evnt[1]);
            }
        }
    }
	
	this.messageToSend = "";
	this.ajax = new Ajax();
	this.msg = function()
	{
		var request = Array();
		request["RT"] = "STEP";
		if (this.messageToSend)
			request["RM"] = this.messageToSend;
		this.messageToSend = "";
		request["c"] = settings.clientId;
        this.ajax.bind('/webdune/server/gameserver.php', 
			function (data) { self.getCommand(data); }, 
			'POST', 
			'formdata', 
			request
		);
	}
	
	
	
	
	var self = this;
	if (!settings.debug)
		this.getCommand();
}

function evt(arg)
{
    // game object id to send to
    this.id = arg[0];
    // action time
    this.time = arg[1];
    // what kinda command is it?
    this.command = arg[2];
}
