/* gameHandle function should contain all logic
 * i made this, because it seems that my draw and mousehandler was doing all the calculating
 * 
 * getPanelContent - Sends data as array object to draw.
 * select - selects a unit. called in mouse handler.
 * controlPanelClick - called when the control panel is clicked, find out where and find out what
 *                  command should we execute
 * doClickCommand - called when the game is clicked, checks if we have a command in the queue, if we do, do that
 *                  command, if we dont, select a unit from that tile if there is any
 */

function GameActions()
{
	this.credits = new Credits();
    this.objects = objects;
    
	
    
    this.doAction = function(obj)
    {
        var date = new Date();
        var progress = 0;
        
        if (obj.action)
        {
            // if the action is not yet started, return.
            if (obj.actionStartTime > time.getTime())
            {
                // this should not happen here.
                deb("should not happen?");
                //return;
            }
        
            // progress of the action, if its 0, the action is ready, if its under 0, we need to minus the time
            // from the next action its gonna do if any.
			/*
			var actionTimeLength = obj.descriptor.actionTimeLength[obj.action];
			if (action == "construct")
				actionTimeLength = obj.constructing.descriptor.actionTimeLength[obj.action];*/
				
			var actionTimeLength = obj.descriptor.actionTimeLength[obj.action];
			if (obj.action == "construct")
				actionTimeLength = obj.constructing.descriptor.actionTimeLength[obj.action];
			
			// game speed modifier.
			actionTimeLength = actionTimeLength/settings.gameSpeed;
			
            var progress = parseInt(obj.actionStartTime)+actionTimeLength-time.getTime();
			var progressPercent = ((time.getTime()-obj.actionStartTime)/actionTimeLength);
            if (progressPercent > 1)
                    progressPercent = 1;
        }
        
        switch (obj.action)
        {
            case "explode":
				if (progressPercent > 0.2)
					obj.direction = 1;
				if (progressPercent > 0.4)
					obj.direction = 2;
				if (progressPercent > 0.6)
					obj.direction = 3;
				if (progressPercent > 0.8)
					obj.direction = 4;
				if (progressPercent == 1)
					obj.direction = 5;
				
                if (progress <= 0)
                {
					map.unoccupyById(obj.id);
					objects.del(obj);
					return;
                }
                break;
            case "shoot":
				obj.fire = true;
				if (progressPercent > 0.2)
					obj.fire = false; 
				if (progressPercent > 0.4)
					obj.fire = true;
				if (progressPercent > 0.6)
					obj.fire = false;
				if (progressPercent > 0.8)
					obj.fire = true;

				
                if (progress <= 0)
                {
					obj.fire = false;
					var damage = obj.descriptor.attackDamage;
					
					// if its a trooper, hp is relative to damage.
					if (obj.descriptor.imgtype == "troop")
						damage = Math.floor(obj.descriptor.attackDamage*(obj.hp/obj.descriptor.maxhp));
					
					obj.attackTarget.hp -= obj.descriptor.attackDamage;
					if (obj.attackTarget.hp <= 0)
					{
						obj.attackTarget.owner = 0;
						obj.attackTarget.action = "explode";
						obj.attackTarget.descriptor.img = "bullets/boom.png";
						// we use the heading to select the explosion image
						obj.attackTarget.direction = 0;
						obj.attackTarget.actionStartTime =  time.getTime()+progress;
						if (userinput.selected.id == obj.attackTarget.id)
							userinput.selected = false;
						obj.attackTarget = false;
					}
                    obj.action = "";
                }
                break;
            case "harvest":
                if (progress <= 0)
                {
					if (obj.spice)
						obj.spice = obj.spice+map.takeSpice(obj.cellXY);
					else
						obj.spice = map.takeSpice(obj.cellXY);
                    obj.action = "";
                }
                break;
            case "unloadspice":
                if (progress <= 0)
                {
					if (obj.spice)
					{
						var give = this.credits.addCredits(obj.spice);
						if (isNumeric(give))
							obj.spice -= give;
						else
							obj.spice = 0;
						//deb(give+" much credits");
					}
					if (!obj.spice)
					{
						var to = map.getNearestFreeSpot(obj.cellXY,obj.descriptor.size);
						if (!to)
						{
							obj.actionStartTime = time.getTime()+progress;
						}
						else
						{
							obj.cellXY = to;
							map.occupy(to, obj.id);
							obj.cellXYAdd = [0,0];
							obj.action = "";
						}
					}
					else
					{
						// reset start time if spice remains in harvester
						obj.actionStartTime = time.getTime()+progress;
					}
                }
                break;
            case "turn":
                if (progress <= 0)
                {
                    // calculate do we need to increase or decrease the heading to get the right heading.
                    // i have no idea why this works, but it does.
                    // i really suck at math.. *snob*
					var headTo = Calc.getHeading(obj.cellXY, obj.nextXY);
					
					/*
					var nextXY = Calc.getCrdFromHeading(headTo);
					var next = [obj.cellXY[0]+nextXY[0],obj.cellXY[1]+nextXY[1]];
					if (map.getOccupied(next) == obj.id)
					{
						nextXY = Calc.getCrdFromHeading(headTo-1);
						next = [obj.cellXY[0]+nextXY[0],obj.cellXY[1]+nextXY[1]];
						if (map.getOccupied(next) == obj.id)
						{
						}
					}*/
					
                    if (obj.direction < headTo)
                        var min = +1;
                    else
                        var min = -1;
                        
                    var compare = Math.abs(obj.direction-headTo);
                    if (compare < 8-compare)
                        obj.direction += min;
                    else
                        obj.direction -= min;
                        
                    if (obj.direction > 7)
                        obj.direction -= 8;
                    if (obj.direction < 0)
                        obj.direction += 8;
                    obj.action = "";
                }
                break;
            case "move":
                
                var nextXY = Calc.getCrdFromHeading(obj.direction);
				
                // occupy next position
                var next = [obj.cellXY[0]+nextXY[0],obj.cellXY[1]+nextXY[1]];
                if (map.getOccupied(next) != obj.id)
                {
					// returns false if its allredy occupied
                    if (!map.occupy(next,obj.id))
                    {
						//
                        //deb(next+" is occupied");
                        obj.action = "";
                        // give up trying
                        obj.destXY = obj.cellXY;
                        return;
                    }
                }
                obj.cellXYAdd[0] = nextXY[0]*progressPercent;
                obj.cellXYAdd[1] = nextXY[1]*progressPercent;
                
                
                
                if (progress <= 0)
                {
                    // unoccupy last position
                    map.unoccupy(obj.cellXY, obj.id);
                    // change the coordinates of the unit
                    obj.cellXY = [obj.cellXY[0]+nextXY[0],obj.cellXY[1]+nextXY[1]];
                    // reset add to pos.
                    obj.cellXYAdd = [0,0];
                    obj.action = "";
                }
                break;
			case "construct":
				obj.buildPercent = progressPercent*100;
				obj.constructing.hp = progressPercent*obj.constructing.descriptor.maxhp-obj.constructing.damageTaken;
				//deb(progressPercent+"*"+obj.constructing.descriptor.maxhp+"-"+obj.constructing.damageTaken+"hp")
				if (progress <= 0)
				{
					if (obj.constructing.descriptor.isUnit)
					{
						var to = map.getNearestFreeSpot(obj.cellXY,obj.descriptor.size);
						if (!to)
						{
							// if the place is occupied, dont change state
							// meaning that we will wait for the other unit to move
							progress = 0;
							break;
						}
						obj.constructing.cellXY = to;
						map.occupy(obj.constructing.cellXY,obj.constructing.id);
						obj.constructing.destXY = obj.constructing.cellXY;
					}
					obj.constructing.isUnderConstruction = false;
					obj.buildPercent = 0;
					obj.action = "";
					obj.constructing = false;
				}
				break;
				
        }
                
        // if there is no action, check if there should be
		// this is the AI part of the game
        if (!obj.action)
        {
            if (obj.descriptor.isUnit)
            {
				
                // check if were not in the tile we want to be
                if (obj.destXY[0] != obj.cellXY[0] || obj.destXY[1] != obj.cellXY[1])
                {
					var isObstacled = true;
					
					var headingChecks = Array(0,1,-1,2,-2,3);
					var next;
					
					for (var i in headingChecks)
					{
						if (!isObstacled)
							continue;
						var heading = Calc.getHeading(obj.cellXY, obj.destXY);
						var nextXY = Calc.getCrdFromHeading(heading+headingChecks[i]);
						// occupy next position
						next = [obj.cellXY[0]+nextXY[0],obj.cellXY[1]+nextXY[1]];
						if (map.getOccupied(next) == obj.id || map.getOccupied(next) == undefined)
						{
							isObstacled = false;
						}
						else if (Math.max(Math.abs(obj.cellXY[0]-obj.destXY[0]),
								Math.abs(obj.cellXY[1]-obj.destXY[1]))
							 	<= obj.descriptor.attackRange)
						{
							isObstacled = false;
							obj.destXY = obj.cellXY;
						}
						else if (obj.harvest)
						{
							var dest  = this.objects.getNearestPosOfType(obj.cellXY,"refinery");
							if (objects.isNextTo(obj.cellXY,map.getOccupied(dest)))
							{
								isObstacled = false;
								obj.destXY = obj.cellXY;
							}
						}
					}
						
							//deb(Math.abs(obj.cellXY[0]-obj.destXY[0])+","+
								//Math.abs(obj.cellXY[1]-obj.destXY[1])
							 	//+"<="+ obj.descriptor.attackRange)
					obj.nextXY = next;
                    if (Calc.getHeading(obj.cellXY, obj.nextXY) == obj.direction)
                    {
                        obj.action = "move";
                    }
                    else
                        obj.action = "turn";
                
					if (obj.preciseStartTime)
					{
						obj.actionStartTime = obj.preciseStartTime;
						delete(obj.preciseStartTime);
					}
					else
						obj.actionStartTime = time.getTime();
                    obj.actionStartTime = obj.actionStartTime+progress;
                }
				else if (obj.attackTarget)
				{
					if (Math.max(Math.abs(obj.cellXY[0]-obj.attackTarget.cellXY[0])
								,Math.abs(obj.cellXY[1]-obj.attackTarget.cellXY[1])) > obj.descriptor.attackRange)
					{
						obj.destXY = obj.attackTarget.cellXY;
					}
					else
					{
						if (Calc.getHeading(obj.cellXY, obj.attackTarget.cellXY) == obj.direction)
						{
							obj.action = "shoot";
							obj.actionStartTime = time.getTime()+progress;
						}
						else
						{
							obj.nextXY = obj.attackTarget.cellXY;
							obj.action = "turn";
							obj.actionStartTime = time.getTime()+progress;
						}
					}
					
				}
                else if (obj.harvest)
				{
					if (obj.spice >= obj.descriptor.storage)
					{
						var dest = this.objects.getNearestPosOfType(obj.cellXY,"refinery");
						if (dest)
						{
							if (!objects.isNextTo(obj.cellXY,map.getOccupied(dest)))
							{
								obj.destXY = dest;
							}
							else
							{
								if (this.objects.hasHarvesterIn([dest[0]+2,dest[1]]))
									obj.action = "";
								else
								{
									// dock the harvester to the refinery
									map.unoccupy(obj.cellXY);
									obj.direction = 6;
									obj.cellXY = [dest[0]+2,dest[1]];
									obj.cellXYAdd = [0,0.5];
									obj.destXY = obj.cellXY;
									obj.action = "unloadspice";
									obj.actionStartTime = time.getTime()+progress;
							    }
							}
						}
						else
						{
							topLayer.setGameMessage("harvester: no refinery :(");
							obj.harvest = false;
						}
					}
					else if (!map.getSpice(obj.cellXY))
					{
						var dest = map.getNearestSpice(obj.cellXY);
						//deb(dest);
						if (dest)
							obj.destXY = dest
						else
						{
							toplayer.setGameMessage("nothing to harvest");
							obj.harvest = false;
						}
					}
					else
					{
						obj.destXY = obj.cellXY;
                        obj.action = "harvest";
						obj.actionStartTime = obj.actionStartTime+progress;
					}
				}
            }
        }
        
        // recall if the time is on minus
		obj.preciseStartTime += progress;
        eventstack.update();
    }
    
    this.deploy = function(obj,time)
    {
        if (obj.action) // lets play it safe
            return;
		// fixes a bug with double clicking deploy
		if (!obj)
			return;
        // morph into a contructionyard
        var obj = this.objects.morph(obj, "constructionyard");
        map.occupyWithin(obj.cellXY, obj.descriptor.size, obj.id);
        this.selected = false;
    }
    
    // do the moving from a to b
    this.move = function(obj, crd, time)
    {
        deb("this.move "+crd+" "+time);
        obj.destXY = crd;
        obj.preciseStartTime = time;
    }
	
	this.attack = function(obj, id,time)
	{
		obj.attackTarget = this.objects.getObjectById(id);
        obj.preciseStartTime = time;
	}
	
	// activate harvesting
    this.harvest = function(obj, time)
    {
		if (obj.harvest)
		{
			obj.harvest = false;
			return;
		}
		obj.harvest = true;
        obj.preciseStartTime = time;
    }
	
	this.construct = function(obj, startTime, desc, crd)
	{
		deb(obj+" "+time+" "+desc+" "+crd);
		var description = new ObjectDescriptor(desc);
		// if you are the owner, minus the contruction cost
		if (obj.owner == settings.playerId)
		{
			if (!this.credits.minusCredits(description.cost))
			{
				deb("not enough credits!");
				return;
			}
		}
		if (description.isUnit)
			var construct = this.objects.addObject([desc,obj.cellXY[0]+1,obj.cellXY[1]+1,obj.owner,1,0]);
		else
			var construct = this.objects.addObject([desc,crd[0],crd[1],obj.owner,1,0]);
		if (!construct.descriptor.isUnit && !construct.descriptor.isFlat)
			map.occupyWithin(crd,construct.descriptor.size, construct.id);
		construct.isUnderConstruction = true;
		obj.constructing = construct;
		obj.action = "construct";
		obj.actionStartTime = time.getTime();
        obj.preciseStartTime = startTime;
	}
    
    // parse the command coming from eventstack
    this.doCommand = function(id, time, com)
    {
		if (com == undefined)
		{
			deb("undefined command "+id)
			return;
		}
    	time = parseInt(time);
        deb("IMCOMING COMMAND "+id+" "+time+" "+com);
        var command = com.split(",");
        var obj = objects.getObjectById(parseInt(command[0]));
        //deb(command[0]+" "+obj.id);
        switch (command[1])
        {
            case "move":
                this.move(obj,[parseInt(command[2]),parseInt(command[3])],time);
                break;
            case "deploy":
                this.deploy(obj,time);
                break;
			case "construct":
				this.construct(obj,time,command[2],[parseInt(command[3]), parseInt(command[4])]);
				break;
			case "harvest":
				this.harvest(obj,time);
				break;
			case "setcredits":
				if (command[0] == settings.playerId)
				{
					this.credits.setCredits(command[2]);
				}
				break;
			case "attack":
				this.attack(obj,parseInt(command[2]),time);
				break;
            default:
				session.chatMessage(com);
		}
    }
}
