/* 
* This is the main js file, here we do all the initializations
*
*/

var ctx;
var canvas;
var map;
var draw;
var mouse;
var objects;
var game;
var time;
var eventstack;
var userinput;
var toplayer;
var playerwindow;
var session;

function Initialize() {
    topLayer = new TopLayer();
    ctx = document.getElementById('canvas').getContext('2d');
    canvas = setCanvas(document.getElementById('canvas'));
    time = new Time();
    eventstack = new EventStack(time);
    objects = new GameObjects(eventstack);
    game = new GameActions(objects);
    userinput = new UserInput();
	session = new Session(settings.clientId);
	playerwindow = new PlayerWindow(session);
    
    var ajax = new Ajax();
    ajax.bind("/"+settings.baseDir+"/data/maps/"+settings.map+".txt", 
        function (data) { map = new Map(data, objects, eventstack); } );
        
    var ajax2 = new Ajax();
    ajax2.bind("/"+settings.baseDir+"/data/toload.php?datadir="+settings.dataDir,
        function (data) { loadImages(data); } );
    
    deb("Initializing..");
    afterLoad();
}

function afterLoad()
{
    deb("loading..");
    if (!IMAGES_PRELOADED || !MAP_PRELOADED || !TIME_SYNCED || !MINIMAP_PRELOADED)
        setTimeout(function() { afterLoad(); },1000);
    else
    {
        deb("loaded");
        time.UNPAUSE();
        draw = new Draw(map, objects, game, ctx);
        mouse = new Mouse(draw, game);
        MainLoop();
    }
}

function setCanvas(canvas)
{
    canvas.style.width = settings.canvasSize[0];
    canvas.style.height = settings.canvasSize[1];
    canvas.style.left = settings.canvasPos[0];
    canvas.style.top = settings.canvasPos[1];
    return canvas;
}

window.onload = function () {
    Initialize();
}
