// global for checking if the loading is ready
MAP_PRELOADED = false;
MINIMAP_PRELOADED = false;



/*
 * TODO: document all properties
 * - getCell() GET x,y RET object cell
 * - serialize
 *     converts the object's _cell to serial.
 * - unserialize
 *     takes: serial and converts it to a cell object array
 *     NOTE: this function allso set's the map's SizeX and SizeY
 */
function Map(mapfile, objects, eventStack) {
    var self = this;
    this.size = [0,0];
    this.name;

	this.fow = new Fow();
    // here we save all unit id's that have occupied a cell.
    this._occupied = Array();
    
    this.getOccupied = function(crd)
    {
        return this._occupied[crd[0]+","+crd[1]];
    }
    
    this.occupy = function(pos, id)
    {
        if (!id)
            deb("invalid occupation id "+id);
            
        if (this._occupied[pos[0]+","+pos[1]])
            return false;
        else
        {
            this._occupied[pos[0]+","+pos[1]] = id;
            // mark as unmoveable by increasing the info value to out of range.
            // but we dont need to remeber the original info value.
            //deb("occupy "+pos+" "+this._occupied[pos[0]+","+pos[1]]);
            if (this._mapInfo[pos[0]+","+pos[1]] < 10) // lets not occupy it twice
                this._mapInfo[pos[0]+","+pos[1]] = parseInt(this._mapInfo[pos[0]+","+pos[1]])+10;
            else
                deb("warning from occupy");
            return true;
        }
    }
    
	// unoccupy pos, id is optional, if it is set, you will unoccupy the pos
	// only if its assigned to specified id.
    this.unoccupy = function(pos, id)
    {
		if (id && this._occupied[pos[0]+","+pos[1]] != id)
			return;
        delete(this._occupied[pos[0]+","+pos[1]]);
        // mark as moveable again
        if (this._mapInfo[pos[0]+","+pos[1]] > 10)
            this._mapInfo[pos[0]+","+pos[1]] = parseInt(this._mapInfo[pos[0]+","+pos[1]])-10;
        else
            deb("warning from unoccupy");
    }
	
    this.unoccupyById = function(id)
    {
		deb("unoccupy by id"+id);
		if (!id)
			return;
        for (var o in this._occupied)
			if (this._occupied[o] == id)
			{
				var arr = o.split(",");
				deb(arr);
				this.unoccupy(arr);
			}
    }
    
    // for buildings usually
    this.occupyWithin = function(pos, size, id)
    {
        deb(pos+","+size);
        for (var x = pos[0]; x < (pos[0]+size[0]); x ++)
            for (var y = pos[1]; y < (pos[1]+size[1]); y ++)
                this.occupy([x,y],id);
    }
    
    // this is called on load.
    // since gameobject is declared before map, we need to occupy created unit's locations here
    this.checkOccupience = function()
    {
        for (i in this.objects._obj)
        {
			if (!this.objects._obj[i].descriptor.isFlat)
				this.occupyWithin(this.objects._obj[i].cellXY, this.objects._obj[i].descriptor.size, this.objects._obj[i].id);
        }
    }
	
	//check for nearest free point around the building
	// XXXXX
	// XBBBX
	// XBBBX
	// XXXXX
	// B's are spots occupied by the building, X's are spots to check
	this.getNearestFreeSpot = function(crd, size)
	{
		for (var x = crd[0]-1; x <= crd[0]+size[0]; x ++)
			for (var y = crd[1]-1; y <= crd[1]+size[1]; y ++)
				if (x == crd[0]-1 || x == crd[0]+size[0] ||
					y == crd[1]-1 || y == crd[1]+size[1])
					if (!this.getOccupied([x,y]) && 
						(x != 0 && y != 0 && x != this.size[0] && y != this.size[1]))
						return [x,y];
		return false;
	}
    
	this.getNearestSpice = function(pos)
	{
		var near = 100;
		var nearest = false;
		for (var key in this._spice)
		{
			var xy = key.split(",");
			if (xy[0] > 0 && xy[1] > 0)
			{
				var comp = (Math.abs(parseInt(pos[0])-parseInt(xy[0]))
					       +Math.abs(parseInt(pos[1])-parseInt(xy[1])));
				if (comp < near)
				{
					nearest = xy;
					near = comp;
				}
			}
		}
		return nearest;
	}
	
    this.eventStack = eventStack;
    
    // map image to load.
    this.map = new Image();
	
    // same for minimap
    this.minimap = new Image();
    
    // map info (like where can i build?)
    this._mapInfo = Array();
    
    // map spice _spice[x,y] = amount
    this._spice = Array();

    this.objects = objects;
    
    // scrollers, used in everything scrolling related.
    this.scroll = [1,1];
    
    // its used to convert coord's. needed in mousehandler
    this.minimapRelation = [0,0];
    // minimap box size is eeded in mousehandler too.
    this.minimapBoxSize = [0,0];
    this.minimapBoxPos = [0,0];
    
    this.visualMapTiles = [0,0];
    
    this.minimapPrecalc = function()
    {
        //alot of the minimaps metadata is in settings
        var s = settings;
        
        // lets count the size in tiles (example: 150x150 map with 15x15 tiles is 10x10)
        this.visualMapTiles = [s.visualMapSize[0]/ s.tileSize,s.visualMapSize[1]/s.tileSize];
        // get the max of map sizes x and y for refrence
        // calculate how much is one tile in minimap pixels 
        // CAUTION floating values
        this.minimapRelation[0] = this.size[0]/s.minimapSize;
        this.minimapRelation[1] = this.size[1]/s.minimapSize;
        
        
        // add the scroller to box's position
        this.minimapBoxPos[0] = s.minimapPos[0]+Math.floor(this.scroll[0]/this.minimapRelation[0]);
        this.minimapBoxPos[1] = s.minimapPos[1]+Math.floor(this.scroll[1]/this.minimapRelation[1]);
        // convert visual map size to minimap box size
        this.minimapBoxSize[0] = Math.floor((this.visualMapTiles[0])/this.minimapRelation[0]);
        this.minimapBoxSize[1] = Math.floor((this.visualMapTiles[1])/this.minimapRelation[1]);
        //deb(this.minimapBoxPos+" "+this.minimapBoxSize,1);
		
    }
    
    
    
    
    // this is called from mousecontrol
    this.minimapHandler = function (crd)
    {
        //alot of the minimaps metadata is in settings
        var s = settings;
        // loop 2 times, once for x, once for y
        for (var i = 0; i <= 1; i++)
        {
            // it is now real game coordinates, so
            // convert to minimap coordinates
            var MinimapCrd = crd[i]-s.minimapPos[i];
            
            var is = MinimapCrd*this.minimapRelation[i];
            this.minimapBoxPos[i] = Math.floor(is);
        
            // minus half of the box size to coords, so that the mouse would be in the middle of the box
            MinimapCrd -= this.minimapBoxSize[i]/2;
        
            
            // convert from minimap coord to game coord. if minimapRelation is confusing, see minimapPrecalc
            MinimapCrd = Math.round(MinimapCrd*this.minimapRelation[i]);
        
            // check if we formed some illegal coords.
            if (MinimapCrd < 1)
                MinimapCrd = 1;
            if (MinimapCrd > this.size[i]-this.visualMapTiles[i]-1) // this part's a bit more tricky
                MinimapCrd = this.size[i]-this.visualMapTiles[i]-1; // basicly just checks that were
                                                                            // still on the map
            
            // finally, give the coords to map.
            this.scroll[i] = MinimapCrd;
            
        }
        //deb(this.minimapBoxPos);
        // define isbuttondown with id 1
        // so that we can call this function again if user wants to drag the mouse.
        //this.IsButtonDown = 1;
    }
    
    
    // parses the map info bit of the file
    this.parseMapInfo = function(serial) {
        arr = new Array();
        var rows = serial.split("|");
        
        for (var y in rows)
        {
            var tiles = rows[y];
            for (var x = 0; x < tiles.length; x ++)
            {
                arr[x+","+y] = tiles.charAt(x);
            }
        }
        return arr;
    }
    
    // takes serial of map, and returns cells array object
    this.unserialize = function (txt)
    {
        var rows = txt.split("\n");
        var loadEnchantment = false;

        for (var i in rows)
        {
            var info = rows[i].split("=");
            var SPICE_REGEX = /spice\[(\d+)\]/;
            
            if (info[0].match(SPICE_REGEX)) {
                var spiceAmount = info[0].replace(SPICE_REGEX, '$1');
                var coords = info[1].split("|");
                for (var b in coords)
                {
					var crd = coords[b].split(",");
                    this._spice[parseInt(crd[0])+","+parseInt(crd[1])] = parseInt(spiceAmount);
                }
            }
            if (info[0] == "sizex")
                this.size[0] = parseInt(info[1]); 
            if (info[0] == "sizey")
                this.size[1] = parseInt(info[1]);
            if (info[0] == "name")
                this.name = info[1];
            if (info[0] == "mapinfo")
			{
                this._mapInfo = this.parseMapInfo(info[1]);
                this.map.onload = function () { 
					MAP_PRELOADED = true; };
                this.map.onerror = function () { deb("mapimage load error"); 
					MAP_PRELOADED = true; };
                this.minimap.onload = function () { 
					MINIMAP_PRELOADED = true; };
                this.minimap.onerror = function () { deb("mini map image load error");
					MINIMAP_PRELOADED = true; };
                this.map.src = "/"+settings.baseDir+"/data/mapgen.php?mapinfo="+info[1]+"&datadir="+settings.dataDir;
				this.minimap.src = "/"+settings.baseDir+"/data/mapgen.php?mapinfo="+info[1]+"&minimap=true&datadir="+settings.dataDir;
            }
            if (info[0] == "objects")
                this.objects.unserialize(info[1]);
            if (info[0] == "events")
                this.eventStack.unserialize(info[1]);
        }
        this.minimapPrecalc();
        this.checkOccupience();
    }
    // lets call it as a constructor
    this.unserialize(mapfile);
    
    this.canBuild = function(pos,size)
    {
        var crd = [parseInt(pos[0]),parseInt(pos[1])];
        /*if (width == 3)
        {
            crd[0] --;
        }
        if (height == 3)
        {
            crd[1] --;
        }*/
        for (var y = crd[1]; y < (parseInt(crd[1])+parseInt(size[1])); y++)
        {
        //deb(y+" "+(parseInt(crd[1])+parseInt(height)));
            for (var x = crd[0]; x < (parseInt(crd[0])+parseInt(size[0])); x++)
            {
                if (this.getInfo([x,y]) !=  1 )
                {
                    return false;
                }
            }
        }
        return true;
    }
    
    this.getSpice = function (crd) {
        var spice = this._spice[crd[0]+","+crd[1]];
        if (spice > 1000)
            return "map/spice_alot.png";
        if (spice)
        {
            return "map/spice.png";
        }
        return false;
    }
	
    this.takeSpice = function (crd) {
        var spice = this._spice[crd[0]+","+crd[1]];
		delete(this._spice[crd[0]+","+crd[1]]);
        return spice;
    }

    this.getInfo = function (crd) {
        if (!this._mapInfo[crd[0]+","+crd[1]])
            return false;
        return this._mapInfo[crd[0]+","+crd[1]];
    }
}
