var TIME_SYNCED = false; // part of starting the game is synching the time.
var TIME_PAUSE = false; // lockstep needs a lock to lock the step

/* This is the time controller, it controls stuff like game speed and game pause.
 * The princible of this is to count the time starting from game start. This time is stored at gameStartTime.
 * When the game gets paused, it increases the pause timer, witch makes the time stand still.
 * So, game time is millseconds from epox, minus game start time, minus game pause time.
 *
 * update - updates time and such
 * getTime - returns real game time.
 * stepTime - returns the time witthin you should send commands example, if  you have lockstep set to 1000ms, and game time is 2234ms, it would return 2000ms
 * showLatency - just show's the latency calculated in update.
 * syncTime - the ajax output on syncing time. takes time before start in millseconds and sets gameStartTime
 */

function Time()
{
    this.date = new Date();
    this.gameStartTime = this.date.getTime();
    this._time = 0;
    this.timeFromLastUpdate = 0;
    this.havePermissionForStep = 0;
    this.currentStep = 0;
	
    this.update = function()
    {
        var date = new Date();
        var nextStep = Math.floor((date.getTime() - this.gameStartTime)/1000);
		//deb("currentStep: "+this.currentStep);
		//deb("nextStep: "+nextStep);
        var timeNow = date.getTime() - this.gameStartTime;
		if (this.currentStep != nextStep)
		{
			if (this.currentStep >= this.havePermissionForStep)
			{
				TIME_PAUSE = true;
			}
			else
			{
				TIME_PAUSE = false;
				this.currentStep += 1;
				
				this.timeFromLastUpdate = timeNow - this._time;
				if (this.timeFromLastUpdate > 999)
					this.timeFromLastUpdate = 999;
				this.gameStartTime = date.getTime() - (this.currentStep*1000)-this.timeFromLastUpdate;
				timeNow = date.getTime() - this.gameStartTime;
			}
		}
		if (timeNow > (date.getTime() - (this.currentStep*1000)-999))
			TIME_PAUSE = true;
        if (TIME_PAUSE)
        {
            this.gameStartTime = date.getTime() - (this.currentStep*1000)-999;
        }
        timeNow = date.getTime() - this.gameStartTime;
        this.timeFromLastUpdate = timeNow - this._time;
        // let's show thease guy's some latency.
        this.showLatency(timeNow);
        this._time = timeNow;
    }
    
    this.PAUSE = function()
    {
        TIME_PAUSE = this._time;
    }
    
    this.UNPAUSE = function()
    {
        TIME_PAUSE = 0;
    }
    
    this.getTime = function()
    {
        if (this._time < 0)
            return 0;
        return this._time;
    }
    
    this.stepTime = function()
    {
        return (Math.floor(this._time/settings.lockStepTime)*settings.lockStepTime);
    }
    
    this.showLatency = function(latency)
    {
        document.getElementById("ping").innerHTML = latency;
    }
    
    
    this.syncTime = function(data)
    {
        var datenow = new Date();
		this.date = datenow;
        var lagAdd = Math.round((datenow.getTime()-this.date.getTime())/2);
        //deb("requestTime / 2 = "+lagAdd+" data: "+data,1);
        this.gameStartTime = datenow.getTime()+parseInt(data)+lagAdd;
		if (!isNumeric(data))
			deb("sync error: "+data);
		else
			TIME_SYNCED = true;
		
		if (settings.debug)
			this.havePermissionForStep = 1000;
    }
	
    // initializion, send ajax time sync request to server
	this.sendTimeSyncRequest = function()
	{
		if (settings.debug)
		{
			self.syncTime(-30000);
			return;
		}
		
		var request = Array();
		request["RT"] = "TIMESYNC";
		request["c"] = settings.clientId;
		var ajax = new Ajax()
        ajax.bind('/webdune/server/gameserver.php', 
			function (data) { self.syncTime(data); }, 
			'POST', 
			'formdata', 
			request
		);

	}
    
    var self = this;
	
	this.sendTimeSyncRequest();
}
