<?php
ini_set('display_errors', '1');
include_once("SessionManager.php");
require_once('ProtocolViolationException.php');

header('Content-Type: text/plain');

try {
    if (!isset($_POST['RT'])) {
        throw new ProtocolViolationException('RT field missing');
    }
    $requestType = $_POST['RT'];
    $requestMessage = isset($_POST['RM']) ? $_POST['RM'] : '';
    $clientId = isset($_POST["c"]) ? $_POST["c"] : '';

    $session = new new_SessionManager();
    $session->sessionSpank();
	$sessionId = false;
    if (!$clientId) {
        if ($requestType != "NEWUSER")
            throw new ProtocolViolationException('Player not registered');

        if (!ctype_alnum($requestMessage) || strlen($requestMessage) > 20 || strlen($requestMessage) < 1)
            throw new ProtocolViolationException("Invalid user name");
        $clientId = $session->createPlayer($requestMessage);
        echo $clientId;
    } else {
    	$session->checkPlayerExistance($clientId);
        $sessionId = $session->getSessionByClientId($clientId);
    }
    $players = $session->sessionSpank($sessionId);
    $session->updatePlayerPing($clientId);
    switch ($requestType) {
        case "NEWSESS":
            if (!ctype_alnum($requestMessage) || strlen($requestMessage) > 20)
                throw new ProtocolViolationException("Invalid session name");
            $session->createSession($requestMessage, $clientId);
            break;
        case "LISTSESS":
            echo json_encode($session->getJoinableSessions());
            break;
        case "SESSPROP":
        	if (!$requestMessage)
        		$sess = $sessionId;
        	else
        		$sess = $requestMessage;
       		$ret["session"] = $session->getSessionProperties($sessionId);
			$ret["players"] = $players;
            echo json_encode($ret);
            break;
        case "NEWUSER":
        	break;
        case "CHATMESSAGE":
        	echo $session->chatMessage($sessionId,$requestMessage);
        	break;
        case "JOINSESS":
        	$session->joinSession($requestMessage,$clientId);
        	break;
        case "STARTGAME":
        	$session->startGame($sessionId, $clientId);
        	break;
        case "TIMESYNC":
        	echo $session->getOrSetGameStartTime($sessionId);
        	break;
        case "STEP":
        	if ($requestMessage)
        		$session->sendEvent($sessionId,$requestMessage);
        	echo $session->getNewCommands($sessionId, $clientId);
        	echo $session->getCurrentStep($sessionId);
        	echo "%".json_encode($players);
        	break;
        default:
            throw new ProtocolViolationException($requestType." not a valid request type");
        	break;
    }
}
catch (Exception $e) {
    header('Content-Type: text/plain', true, 500);
    echo $e->getMessage();
}
